<script lang="ts" setup>
import ConfirmDialog from "@/components/ConfirmDialog.vue";
import { useProductStore } from "@/stores/product";
import { onMounted, ref } from "vue";
import ProductDialog from "./ProductDialog.vue";

const productStore = useProductStore();
const confirmDlg = ref();
const backendURL = import.meta.env.VITE_BACKEND_URL;

onMounted(async () => {
  // confirmDlg.value.openDialog("Please Confirm", "คุณต้องการลบ xxx หรือไม่");
  await productStore.getProducts();
  console.log(import.meta.env.VITE_BACKEND_URL);
});

const deleteProduct = async (id: number) => {
  try {
    await confirmDlg.value.openDialog(
      "Please Confirm",
      `คุณต้องการลบ ${id} หรือไม่`
    );
    await productStore.deleteProduct(id);
  } catch (e) {
    console.log(e);
  }
};
</script>
<template>
  <ProductDialog></ProductDialog>
  <v-btn @click="productStore.dialog = true">Add New</v-btn>
  <v-table>
    <thead>
      <tr>
        <th>ID</th>
        <th>Image</th>
        <th>Name</th>
        <th>Price</th>
        <th>Operations</th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="item of productStore.products" :key="item.id">
        <td>{{ item.id }}</td>
        <td>
          <v-img
            :src="`${backendURL}/products/image/${item.image}`"
            height="128px"
          ></v-img>
          <!-- <v-img
            :src="`http://localhost:3000/products/${item.id}/image`"
            height="128px"
          ></v-img> -->
          <!-- <v-img
            :src="`${backendURL}/products/${item.id}/image`"
            height="128px"
          ></v-img> -->
        </td>
        <td>{{ item.name }}</td>
        <td>{{ item.price }}</td>
        <td>
          <v-btn class="mr-5" @click="productStore.editProduct(item)"
            >Edit</v-btn
          ><v-btn @click="deleteProduct(item.id!)">Delete</v-btn>
        </td>
      </tr>
    </tbody>
  </v-table>
  <ConfirmDialog ref="confirmDlg"></ConfirmDialog>
</template>
